=== debian/changelog ===
glfw3 (3.3.6-1~mx21ahs+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-21 AHS.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Tue, 01 Feb 2022 10:12:08 -0500

glfw3 (3.3.6-1) unstable; urgency=medium

  * New upstream version 3.3.6.
    + Fix bug around XIM. (Closes: #1003481)
  * debian/: Apply "wrap-and-sort -abst".
  * debian/control:
    + Add myself into uploaders list.
    + Bump Standards-Version to 4.6.0.
    + Bump debhelper compat to v13.
  * debian/watch: Update to v4 format.
  * debian/patches: Refresh patches using "gbp pq".

 -- Boyuan Yang <byang@debian.org>  Sat, 29 Jan 2022 22:54:32 -0500

glfw3 (3.3.2-2) unstable; urgency=high

  * Team upload.
  * debian/tests/CMakeLists.txt: Bump minimum required CMake version
    to 3.7.2 to avoid CMake DeprecationWarning in autopkgtest stderr.
    (Closes: #994496)

 -- Boyuan Yang <byang@debian.org>  Tue, 05 Oct 2021 12:58:38 -0400
