## glfw3 3.3.7

=== debian/changelog ===
glfw3 (3.3.7-1) unstable; urgency=medium

  * New upstream release. 

 -- Boyuan Yang <byang@debian.org>  Mon, 11 Apr 2022 13:12:22 -0400
