## glfw3 3.3.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.0...3.20 FATAL_ERROR)
 
-project(GLFW VERSION 3.3.6 LANGUAGES C)
+project(GLFW VERSION 3.3.8 LANGUAGES C)
 
 set(CMAKE_LEGACY_CYGWIN_WIN32 OFF)
 
@@ -266,7 +266,6 @@
 
     include(CheckIncludeFiles)
     include(CheckFunctionExists)
-    check_include_files(xkbcommon/xkbcommon-compose.h HAVE_XKBCOMMON_COMPOSE_H)
     check_function_exists(memfd_create HAVE_MEMFD_CREATE)
 
     if (NOT CMAKE_SYSTEM_NAME STREQUAL "Linux")
@@ -339,3 +338,6 @@
 
 #--------------------------------------------------------------------
 # Add subdirectories
+#--------------------------------------------------------------------
+add_subdirectory(src)
+
