=== debian/changelog ===
glfw3 (3.3.8-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sun, 24 Jul 2022 10:46:31 -0400
