=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: glfw3
 Section: libs
 Priority: optional
-Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
-XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders:
  Mahyuddin Susanto <udienz@ubuntu.com>,
  Roman Valov <roman.valov@gmail.com>,
@@ -26,7 +25,7 @@
  wayland-protocols (>= 1.15) [linux-any],
 Build-Depends-Indep:
  doxygen,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://www.glfw.org/
 Vcs-Git: https://salsa.debian.org/games-team/glfw3.git
 Vcs-Browser: https://salsa.debian.org/games-team/glfw3
