## glfw3 3.3.9

=== debian/changelog ===
glfw3 (3.3.9-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/02_remove-pkgconfig-requires.patch: Refreshed.
  * debian/control: Replace obsolete dependency:
    libgl1-mesa-dev => libgl-dev, libglvnd-dev.

 -- Boyuan Yang <byang@debian.org>  Sat, 16 Dec 2023 14:34:44 -0500
