=== debian/control ===
--- 
+++ 
@@ -13,7 +13,8 @@
  dh-exec,
  extra-cmake-modules (>= 1.6) [linux-any],
  libegl1-mesa-dev [linux-any],
- libgl1-mesa-dev | libgl-dev,
+ libgl-dev,
+ libglvnd-dev,
  libwayland-dev [linux-any],
  libx11-dev,
  libxcursor-dev,
@@ -25,7 +26,7 @@
  wayland-protocols (>= 1.15) [linux-any],
 Build-Depends-Indep:
  doxygen,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://www.glfw.org/
 Vcs-Git: https://salsa.debian.org/games-team/glfw3.git
 Vcs-Browser: https://salsa.debian.org/games-team/glfw3
@@ -61,7 +62,8 @@
 Pre-Depends:
  ${misc:Pre-Depends},
 Depends:
- libgl1-mesa-dev | libgl-dev,
+ libgl-dev,
+ libglvnd-dev,
  libglfw3 (= ${binary:Version}) | libglfw3-wayland (= ${binary:Version}) [linux-any],
  ${misc:Depends},
 Recommends:
