## glfw3 3.3.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,6 @@
 cmake_minimum_required(VERSION 3.0...3.20 FATAL_ERROR)
 
-project(GLFW VERSION 3.3.8 LANGUAGES C)
-
-set(CMAKE_LEGACY_CYGWIN_WIN32 OFF)
+project(GLFW VERSION 3.3.10 LANGUAGES C)
 
 if (POLICY CMP0054)
     cmake_policy(SET CMP0054 NEW)
@@ -47,6 +45,7 @@
 else()
     set(GLFW_LIB_NAME glfw3)
 endif()
+set(GLFW_LIB_NAME_SUFFIX "")
 
 if (GLFW_VULKAN_STATIC)
     if (BUILD_SHARED_LIBS)
@@ -198,6 +197,10 @@
     if (GLFW_USE_HYBRID_HPG)
         set(_GLFW_USE_HYBRID_HPG 1)
     endif()
+
+    if (BUILD_SHARED_LIBS)
+        set (GLFW_LIB_NAME_SUFFIX "dll")
+    endif()
 endif()
 
 #--------------------------------------------------------------------
@@ -338,6 +341,3 @@
 
 #--------------------------------------------------------------------
 # Add subdirectories
-#--------------------------------------------------------------------
-add_subdirectory(src)
-
