=== debian/changelog ===
glfw3 (3.3.10-1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 01:07:59 +0000

glfw3 (3.3.10-1) unstable; urgency=medium

  * Team upload.
  * New upstream 3.3.x series release.
  * debian/control: Remove myself from uploaders list.

 -- Boyuan Yang <byang@debian.org>  Mon, 26 Feb 2024 20:06:53 -0500
