=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: glfw3
 Section: libs
 Priority: optional
-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders:
  Mahyuddin Susanto <udienz@ubuntu.com>,
  Roman Valov <roman.valov@gmail.com>,
  James Cowgill <jcowgill@debian.org>,
- Boyuan Yang <byang@debian.org>,
 Build-Depends:
  cmake (>= 3.0),
  debhelper-compat (= 13),
